///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// version of close economy DSGE model has 41 endogenous variables
// modifying model by excluding goverment sector

var 
pid_hat,                % [1] domestic inflation
pic_hat,                % [2] consumption inflation
w_hat,                  % [3] real wage
c_hat,                  % [4] real consumption
i_hat,                  % [5] domestic investment
mult_hat,               % [6] money growth
H_hat,                  % [7] labor
kbar_hat,               % [8] utilisation capital
k_hat,                  % [9] capital
q_hat,                  % [10] real cash balance
mbar_hat,               % [11] money 
mu_hat,                 % [12]
gammacd_hat,            % [13]
gammaid_hat,            % [14]
mc_hat,                 % [15]
R_hat,                  % [16]
Rf_hat,                 % [17]
eps_hat,                % [18] stationary technology shock
muz_hat,                % [19]
zetac_hat,              % [20]
zetah_hat,              % [21]
lambdaf_hat,            % [22]
upsilon_hat,            % [23]
tauk_hat,               % [24]
tauy_hat,               % [25]
tauc_hat,               % [26]
tauw_hat,               % [27]
g_hat,                  % [28]
epsR_hat,               % [29]
y_hat,                  % [30]
rk_hat,                 % [31]
zetatilde_hat,          % [32]
piT_hat,                % [33]
data_pid,               % [34]
data_wp,                % [35]
data_c,                 % [36] 
data_i,                 % [37]     
data_R,                 % [38]
data_y,                 % [39] 
E_t;                    % [40]
        

% pimc_hat,             % [1] imported cons. price in equa.6
% pimi_hat,             % [2] imported invs. price in equa.7
% gammamcd_hat,         % [6] the relative price between imported cons and domesstic goods price in equa. 20
% gammamid_hat;         % [7]the relative price between imported invs and domesstic goods price in equa. 21
% pix_hat,              % [3] exporting price in equa.8
% Pkprime_hat,          % [4] foreign bond price in equa. 16
% deltaS_hat,           % [5] change in exchange rate in equa. 17
% gammaxstar_hat,       % [8] the relative price between home export and foreign goods price in equa. 24
% mcx_hat,              % [9]The Law of one price in equa. 25% Gerret include E_t
% gammaf_hat,           % [10] relative price used in importing and exporting firm in equa.26
% x_hat,                % [11] real exchange rate
% mcmc_hat,             % [12] The marginal cost of importing cons.firms in equa.27
% mcmi_hat,             % [13] The marginal cost of importing ivs.firms in equa.28
% a_hat,                % [14] net foreign asset in equa.32
% pistar_hat,           % [15] foreign inflation in equa.34
% ystar_hat,            % [16] foreign output in equa.35
% Rstar_hat,            % [17] foreign interest rate in equa.36
% data_x,               % [18] obs.export in equa.43
% data_m,               % [19] obs.import in equa.44
% net_export_hat        % [20] obs. trade balance in equa.45
% data_ystar,           % [21] obs.foreign output in equa.49
% data_pistar,          % [22] obs.foreign inflation in equa.50
% data_Rstar,           % [23] obs. foreign interest rate in equa.51
% etamc_hat,            % [24] sub.elas import cons goods in equa.57
% etami_hat,            % [25] sub.elas import invs goods in equa.58
% phitilde_hat,         % [26] risk primium in equa.59
% lambdax_hat,          % [27] markup export in equa.62
% data_pii,             % [28] investment inflation
% data_pic              % [29] consumption price
        
varexo  
eps_epshat,             % [1]
eps_muzhat,             % [2]
eps_nuhat,              % [3]
eps_zetachat,           % [4]
eps_zetahhat,           % [5]
eps_zetaqhat,           % [6]
eps_lambdafhat,         % [7] 	
eps_upsilonhat,         % [8]
eps_epsRhat,            % [9]
eps_piThat,             % [10]
eps_muhat;              % [11]

% eps_pistarhat,        % [1] shock of foreign inflation in foreign VAR
% eps_ystarhat,         % [2] shock of foreign output in foreign VAR
% eps_Rstarhat,         % [3] shock of foreign interest rate in foreign VAR
% eps_lambdaxhat ,      % [4] shock of markup export 
% eps_etamchat,         % [5] shock of sub.elas import.cons goods
% eps_etamihat,         % [6] shock of sub.elas impr.invs goods
% eps_phitildehat,      % [7] shock of risk primium 
% eps_taukhat,          % [8] shock of cap.income tax
% eps_tauyhat,          % [9] shock of income tax
% eps_tauchat,          % [10] shock of	consumption tax
% eps_tauwhat,          % [11] shock of wage tax
% eps_ghat,             % [12] shock of gover.tax
% eps_zetatildehat,     % [13] shock of asymmetric technology 

parameters  
Al,	
Aq,	
b,	
beta,	
cbar,	
cdbar,	
cdfbar,	
csbar,	
D1,	
D2,	
D3,	
D4,	
delta,	
epspolicy,	
epsz,	
etac,	
etaf,	
etai,            
etamc,	
etami,	
gammacd,	
gammacmc,	
gammadc,	
gammadi,	
gammaf,	
gammaid,	
gammaimi,	
gammamcd,	
gammamid,	
gammapi1,	            
gammapi2,	
gammapi3,	
gammaq1,	
gammaq2,	
gammaq3,	
gammax, 
gammay1,	
gammay2,	
gammay3,	
gbar,	
Hbar,	
ibar,	
idbar,           
idfbar,	
isbar,	
kbar,	
koverH,	
lambdaf, 
lambdaw,	
mbar,	
mcbar,	
mu,	
muz,	
nubar,	
omegac,	
omegai,	
phi,	
phitilde,	
phiz,            
piebar, 
piecbar,	
Pii1,	
Pii2,	
Pii3,	
Piim,	
Piimc,	
PiimcPc,	
Piimi,	
PiimiPi,	
PiiTot,	
Pkprime,	
qbar,	
ratioc,	
ratiog,	
ratioi,	
ratiox,	           
ratioz,	
Rbar,	
Rfbar,	
rhoeps,	
rhoetamc,	
rhoetami,	
rhoiota,	
rholambda,	
rhomuz,	
rhonu,	
rhophitilde,	
rhoR,	
rhozetac,	
rhozetah,            
rhozetaq,	
rkbar,	
sharek,	
sigmaa,	
sigmal,	
sigmaq,	
SS,	
tauc,	
tauk,	
tauw,	
tauy,	
wbar, 
xbar,	
xid,	
ximc, 
ximi,	
xiw,	            
ybar,	
ybar1,	
ybar2,	
ybar3,	
zbar, 
bw,	
eta0,	
eta1,	
eta2,	
eta3,	
eta4,   
eta5,	
eta6,	
eta7,	
eta8,	
eta9, 
eta10, 
eta11, 
eta12, 
eta13, 
eta14, 
eta3bar,            
rhotauk,	
rhotauy,	
rhotauc,	
rhotauw,	
rhog,	
rhoepsR,	
rhopistar,	
rhoystar,	
rhoRstar, 
cmbar, 
imbar,           
rholambdax, 
rhozetatilde, 
xix, 
kappaw, 
kappad,
rhopietarget,
kappax,
rdeltapi , 
rpie , 
rx , 
ry , 
rdeltay, 
kappamc , 
kappami, 
xie,
phitildes,
lambdamc,
lambdami;



////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Assigning the parameter their Bayesian estimates.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


% estimating parameters			
xiw             =	    0.765	; %[1]
xid             =	    0.825	; %[2]
kappad          =	    0.227	; %[3]
kappaw          =	    0.323	; %[4]
SS              =	    8.584	; %[5]
b               =	    0.679	; %[6]
lambdaf         =	    1.195	; %[7]
muz             =	    1.0041	; %[8]
rhomuz          =	    0.845	; %[9]
rhoeps          =	    0.925	; %[10]
rhoiota         =	    0.694	; %[11]
rhozetac        =	    0.657	; %[12]
rhozetah        =	    0.270	; %[13]
rhoR            =	    0.913	; %[15]
rpie            =	    1.674	; %[16]
rdeltapi        =	    0.098	; %[17]
ry              =	    0.125	; %[18]
rdeltay         =	    0.178	; %[19]


//Calibr params (no need to estimate)
sigmaq      =	10.62	;% real cash holding elasticity calibrated based on
sigmaa      =	0.049	;% capital utilisation cost,no variable capital utilization, other literatures, such as
nubar       =	1;   	 % share of wage in advance is calibrated based on literatures                                                
tauk        =	0	;// gover. Param, it is set as o then deriving the form as Altig (2005)and CEE(2005)
tauw        =	0   ;//0.3	govern. Parma Phuong 28.6;
%% set all markup shocks are the White Noise as Adofson..(2007)
rholambdax	=	0	; // persistent parameter of the markup export shock
rhoetamc	=	0	; // persistent parameter of the markup import in consumption goods shock
rhoetami	=	0	; // persistent parameter of the markup import in investment goods shock
rholambda	=	0	; // persistent parameter of the  domestic markup shock
%.........................................................................
% Goverment parameters....................................................
rdeltax     =	0	;// govern. pram
rhotauk     =	0   ;// govern. parm Phuong 28,6 0.9	;
rhotauw     =	0   ;// govern. pram Phuong 28.6 0.9	;
epstauk     =	0   ;// govern. pram Phuong 28.6 1	;
epstauw     =	0   ;// govern. pram Phuong 28.6 1	;
%.........................................................................
muz         =   1.0041;
mu          =	1.01	;//Money growth rate,pg modified
beta        =	0.999	;// Pg bases on Justiniano & Preston (2010). This calibrated param. is not so diff                       
sigmal      =	1	;// labor suppy elasticity,This calibration is common in literatures, such as                    
delta       =	0.013;	// depreciation rate, png modify according to AUS                        
sharek      =	0.25;%0.29	; //share of capital in production function, some literatures related to AUS,such as                          
lambdaw     =	1.05	;// wage markup, no modification is needed                         
ratiog      =	0; // govern. pram pg modify 28,60.3	;
tauy        =	0; // govern. pram 0.3	; //Pg 28.6
tauc        =	0; // govern. pram 0.24; //Pg 28.6
Al          =	6.5	; //labor disutility param., Pg modify based on literatures, such as                     
Aq          =	0.1	;// Cash in Utility function parm.,
%%No role in the model................................................
gammaf      =	1	;
gammapi1	=	0	;
gammaq1     =	0	;
gammaq3     =	0	;
%.........................................................................
rhoepsR     =	0	;           % the persistent parameter in monetary policy shock process
gammay1     =	0	;           % no role
rhopietarget	=	0.975	;   %  Smet & Woulter (2003):1 % Adoflson..(2007): 0.975                             
rhonu       =	0	;           % no role
rhozetaq	=	0	;           % no role
epsmdfi     =	0	;           % no role
epsmdhh     =	0	;           % no role
xie         =   0.7975   ; // 0 //  change made by Gerret from 0 to 0.7975, 27.06.2017

%% shutting off to turn into close economy DSGE model
ximc            =	    0	;       % [1] Calvo domestic price
ximi            =	    0	;       % [2] Calvo import cons price
xix             =	    0	;       % [3] Calvo export price
kappamc         =       0;          % [4] indexation price for importing cons. firm
kappami         =       0;          % [5] indexation price for importing invs. firm
kappax          =       0;          % [6] indexation price for exporting firm
lambdamc        =	    1;          % [7] Markup imported consumption
lambdami        =	    1;          % [8] Markup imported investment
etai            =	    1000^10;    % [9] Sub. els invest
etaf            =	    0	;       % [10] Sub. els foreign
etac            =	    1000^10	;   % [11] % elasticity of substition  btw domestic goods and  foreign consumption goods 
omegac          =	    0;          % [12] % share of import in consumption, Jaaskela and Nimark (2011):0.2
omegai          =	    0;          % [13] 0.5 is standard // share of import in investment, Jaaskela and Nimark (2011):0.5
phitildes       =	    0   ;       % [14]  UIP modification 
phitilde        =	    0	;       % [15] risk premium
rx              =	    0	;       % [16] parameter for real exchange rate
rhophitilde     =	    0;          % [17] Unit root risk premium
rhozetatilde	=	    0	;       % [18] asymertry tech shock

model(linear);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//ENDOGENOUS VARIABLES
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

%--------------------------------------- 2.1.FIRMS -------------------------------------------------------------
% [1] Production function equa.2.4     
y_hat = lambdaf*((1-sharek)*H_hat + sharek*k_hat - sharek*muz_hat + eps_hat ) ;

% [2] The inclusion of the gross effective nominal  rate interest 2.10  
Rf_hat = (nubar*Rbar/(nubar*Rbar+1-nubar))*R_hat(-1);

% [3] The scaled equilibrium rental rate of capital 2.14
rk_hat = muz_hat + w_hat + Rf_hat + H_hat - k_hat;

% [4] The real marginal cost 2.15
mc_hat = sharek*(muz_hat + H_hat - k_hat) + w_hat + Rf_hat - eps_hat;

% [5] Domestic phillip curve 2.17
pid_hat = piT_hat + (beta/(1+kappad*beta))*(pid_hat(+1) - rhopietarget*piT_hat) +  (kappad/(1+kappad*beta))*(pid_hat(-1) - piT_hat) 
            + (((1-xid)*(1-beta*xid))/(xid*(1+kappad*beta)))*( mc_hat) + lambdaf_hat   
            -(kappad*beta*(1-rhopietarget)/(1+kappad*beta))*piT_hat ;

% [9] domestic inflation or domestic price aggregate
pic_hat = ((1-omegac)*((( (1-omegac) + omegac*((lambdamc/(lambdamc-1))/((lambdamc/(lambdamc-1))-1))^(1-etac) )^(1/(1-etac))))^(-(1-etac)))*pid_hat;

%------------------------------------------ 2.2. HOUSEHOLDS -----------------------------------------
% [10] Euler consumption equa.2.51     
c_hat = -(1/(muz^2 + beta*b^2))*(-b*beta*muz*c_hat(+1) -b*muz*c_hat(-1) + b*muz*(muz_hat - beta*muz_hat(+1)) 
        +(muz-b*beta)*(muz-b)*mult_hat + (tauc/(1+tauc))*(muz-b*beta)*(muz-b)*tauc_hat + (muz-b*beta)*(muz-b)*gammacd_hat)
        -zetac_hat ;% Phuong modify 31.8

% [11] F.O.C w.r.t m(t+1) equa.2.52, appendix page 74
mult_hat = mult_hat(+1) - muz_hat(+1) + (1/mu)*(mu - beta*tauk)*R_hat - pid_hat(+1) + (1/mu)*(tauk/(1-tauk))*(beta - mu)*tauk_hat(+1);

% [12] Law of motion for capital equa.2.54 B.12   
kbar_hat = (1-delta)*(1/muz)*kbar_hat(-1) - (1-delta)*(1/muz)*muz_hat + (1-(1-delta)*(1/muz))*upsilon_hat + (1-(1-delta)*(1/muz))*i_hat;

% [13] domestic investment equa.2.55
i_hat = (1/((SS*muz^2)*(1+beta)))*((SS*muz^2)*(i_hat(-1) + beta*i_hat(+1) - muz_hat + beta*muz_hat(+1))  +  upsilon_hat - gammaid_hat );

% [14] Capicity utilization rate equa.2.56 B.13 deriving from the utilisation rate r(t)=K(t)/KBar(t)
k_hat = kbar_hat(-1) + (1/sigmaa)*rk_hat - (1/sigmaa)*(tauk/(1-tauk))*tauk_hat; %deriving from the utilisation rate r(t)=K(t)/KBar(t)

% [15] real cash balance equa.2.57
q_hat = (1/sigmaq)*((tauk/(1-tauk))*tauk_hat - mult_hat - (Rbar/(Rbar-1))*R_hat(-1));


% [16] Money growth B.15
mbar_hat(-1) = mbar_hat + pid_hat + muz_hat - mu_hat;

% [17] domesic wage equa.2.63
w_hat = -(1/(sigmal*lambdaw - bw*(1+beta*(xiw^2))))*((((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*xiw)*w_hat(-1) 
+ (((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*beta*xiw)*w_hat(+1) 
+ (-((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*xiw)*pid_hat 
+ (((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*beta*xiw)*pid_hat(+1) 
+ (((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*kappaw*xiw)*pic_hat(-1) 
+ (-((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*beta*kappaw*xiw)*pic_hat 
- ((-((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*xiw) 
+ rhopietarget*(((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*beta*xiw) 
+ (((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*kappaw*xiw) 
+ rhopietarget*(-((lambdaw*sigmal - (1-lambdaw))/((1-beta*xiw)*(1-xiw)))*beta*kappaw*xiw))*piT_hat
+ (1-lambdaw)*mult_hat 
+ (-(1-lambdaw)*sigmal)*H_hat 
+ (-(1-lambdaw)*(tauy/(1-tauy)))*tauy_hat 
+ (-(1-lambdaw)*(tauw/(1+tauw)))*tauw_hat) 
- zetah_hat;    % p modi (-(1-lambdaw))*zetah_hat )   

%----------------------------------------- 2.3. GOVERNMENT--------------------------------------
% is proxy as the short-run SVAR with OLS method. It is estimated by EVIEWS
// shutting down all government variables

% [18] capital tax
tauk_hat=0;

% [19] capital tax
tauw_hat=0;

% [20] income tax
tauy_hat=0;

% [21] consumption tax
tauc_hat=0;

% [22] government tax
g_hat=0;      

% --------------------------------------- 2.4 RELATIVE PRICES--------------------------------------------

% [23] The relative price between aggregate consumption and domestic goods (Pc/P) 2.68
gammacd_hat =0;

% omegac*((( (1-omegac)*(((lambdamc/(lambdamc-1))-1)/(lambdamc/(lambdamc-1)))^(1-etac) + omegac )^(1/(1-etac)))^(-(1-etac)))*gammamcd_hat;
%gammamcd_hat=0;

% [24] The relative price between aggregate investment and domestic goods (Pi/P)2.69
gammaid_hat =0;
% omegai*((( (1-omegai)*(((lambdami/(lambdami-1))-1)/(lambdami/(lambdami-1)))^(1-etai) + omegai )^(1/(1-etai)))^(-(1-etai)))*gammamid_hat;



%------------------------------------ 2.5. CENTRAL BANK --------------------------------------------------
% [25] Central bank policy as Smets & Wouters Rule
//Smets & Wouters Rule
R_hat = rhoR*R_hat(-1) + (1-rhoR)*(piT_hat  + rpie*(pic_hat(-1) - piT_hat) + ry*y_hat(-1) ) + rdeltapi*(pic_hat-pic_hat(-1)) 
        +rdeltay*(y_hat-y_hat(-1))  + epsR_hat; 

% [26] real exchange rate
%x_hat =  -omegac*(( (1-omegac)*(((lambdamc/(lambdamc-1))-1)/(lambdamc/(lambdamc-1)))^(1-etac) + omegac )^(1/(1-etac)))^(-(1-etac))*gammamcd_hat - gammaxstar_hat - mcx_hat;


%%----------------------------------- 2.6. MARKET CLEARING CONDITION -------------------------------------
% [27] The aggregate resource constraint 2.78, 2.81 (B.11) (Market Clearing Condition)
 H_hat*(lambdaf*(1-sharek)) = ((1-omegac)*((( (1-omegac) + omegac*((lambdamc/(lambdamc-1))/((lambdamc/(lambdamc-1))-1))^(1-etac) )^(1/(1-etac)))^etac)*(cbar/ybar)*(c_hat + etac*gammacd_hat) 
                                    +(1-omegai)*((( (1-omegai) + omegai*((lambdami/(lambdami-1))/((lambdami/(lambdami-1))-1))^(1-etai) )^(1/(1-etai)))^etai)*(ibar/ybar)*(i_hat + etai*gammaid_hat)
                                    +(gbar/ybar)*g_hat
                                    +((gammaf^etaf)*xbar/ybar)*( zetatilde_hat)
                                    +(1-tauk)*rkbar*(kbar/ybar)*(1/muz)*(k_hat-kbar_hat(-1))
                                    -lambdaf*eps_hat
                                    -lambdaf*sharek*(k_hat-muz_hat) );                                    


% [28] Loan market clearing condition 2.85, B.16
((mu*mbar)/(piebar*muz))*mu_hat = -((mu*mbar)/(piebar*muz))*mbar_hat(-1) + ((mu*mbar)/(piebar*muz))*pid_hat + ((mu*mbar)/(piebar*muz))*muz_hat  
                                  +qbar*q_hat + nubar*wbar*Hbar*( w_hat + H_hat);


%-----------------------------// *** MEASUREMENT EQUATION **/------------------------------------------------
% [29] Link with obs. domestic inflation
data_pid = 400*(piebar-1)*piebar + 4*piebar*pid_hat;

% [30] link with obs. domestic wage
data_wp = 100*log(muz) + w_hat-w_hat(-1) + muz_hat;

% [31] Link to obs. domestic consumption
data_c = 100*log(muz) + c_hat-c_hat(-1) + muz_hat;
% + (cbar/(cdbar+cmbar))*etac*(cdbar/cbar)*(cmbar/cbar)*( ((( (1-omegac)*(((lambdamc/(lambdamc-1))-1)/(lambdamc/(lambdamc-1)))^(1-etac) + omegac )^(1/(1-etac)))^-1) - ((( (1-omegac) + omegac*((lambdamc/(lambdamc-1))/((lambdamc/(lambdamc-1))-1))^(1-etac) )^(1/(1-etac)))^-1) )*(gammamcd_hat-gammamcd_hat(-1))

% [32] Link to obs. domestic  investment
data_i = 100*log(muz) + i_hat-i_hat(-1)
      + (1-tauk)*rkbar*kbar*(1/muz)*((k_hat - kbar_hat) - (k_hat(-1) - kbar_hat(-1)) ) 
      + muz_hat ;
%+ (ibar/(idbar+imbar))*etai*(idbar/ibar)*(imbar/ibar)*( ((( (1-omegai)*(((lambdami/(lambdami-1))-1)/(lambdami/(lambdami-1)))^(1-etai) + omegai )^(1/(1-etai)))^-1) - ((( (1-omegai) + omegai*((lambdami/(lambdami-1))/((lambdami/(lambdami-1))-1))^(1-etai) )^(1/(1-etai)))^-1) )*(gammamid_hat-gammamid_hat(-1)) 
%      + 

% [33] Link to obs. domestic  interest rate
data_R = 400*(Rbar-1)*Rbar + 4*Rbar*R_hat; 

% [34] Link to obs. domestic output
data_y = 100*log(muz) + y_hat-y_hat(-1) + muz_hat;

% [35] Link to obs. domestic CPI price (CPI)
%data_pic = 400*(piebar-1)*piebar + 4*piebar*pic_hat + 4*piebar*(tauc/(1+tauc))*(tauc_hat - tauc_hat(-1));

% [36] Link to obs. domestic employment
E_t = beta/(1+beta)*E_t(+1)+(1/(1+beta))*E_t(-1)+((1-xie)*(1-beta*xie))/((1+beta)*xie)*(H_hat-E_t); // change made by Gerret, 27.06.2017 becasue swedish data has no data about employment

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//EXOGENOUS VARIABLES (The exog vars in Dynare are really the innovations to the exog vars below)
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// [37] Stationary technology
eps_hat         = rhoeps*eps_hat(-1)            + eps_epshat;

// [38] Nonstationary technology 
muz_hat         = rhomuz*muz_hat(-1)            + eps_muzhat;

// [39]Consumption preference
zetac_hat       = rhozetac*zetac_hat(-1)        + eps_zetachat;

// [40]Labor supply 
zetah_hat       = rhozetah*zetah_hat(-1)        + eps_zetahhat;

//[41]Domestic markup
lambdaf_hat     = rholambda*lambdaf_hat(-1)     + eps_lambdafhat;


// [42] Investment specific technology
upsilon_hat     = rhoiota*upsilon_hat(-1)       + eps_upsilonhat;

// [43] Monetary policy
epsR_hat        = rhoepsR*epsR_hat(-1)          + eps_epsRhat;

// [44] Asymmetric technology
 zetatilde_hat   = rhozetatilde*zetatilde_hat(-1); %+ eps_zetatildehat;

// [45]Inflation target
piT_hat         = rhopietarget*piT_hat(-1)      + eps_piThat;
end;

// *** Observed data ***

% Gerret & Pg, working on this
varobs data_pid data_wp data_c data_i 
data_R E_t data_y ;
% data_pic x_hat data_x data_m data_ystar data_pistar data_Rstar

steady;
check;

%shocks;
//Stationary technology 
%var eps_epshat = (epsteche)^2;

//Nonstationary technology 
%var eps_muzhat = (epstechz)^2;

//Consumption preference
%var eps_zetachat = (epszetac)^2;

//Labor supply
%var eps_zetahhat = (epszetah)^2;

//Domestic markup
%var eps_lambdafhat = (epslf)^2;

//Substitution elasticity imp cons goods
%var eps_etamchat = (epsetamc)^2;

//Substitution elasticity imp inv goods
%var eps_etamihat = (epsetami)^2;

//Risk premium
%var eps_phitildehat = (epsphiex)^2;

//Investment specific technology
%var eps_upsilonhat = (epsu)^2;

//Monetary policy
%var eps_epsRhat =0.0894 ;

//Markup export
%var eps_lambdaxhat = (epslx)^2;

//Asymmetric technology
%var eps_zetatildehat = (epszstar)^2;

//Inflation target
%var eps_piThat = (epspiebar)^2;

//Foreign VAR
%var eps_pistarhat = (1)^2;
%var eps_ystarhat  = (1)^2;
%var eps_Rstarhat  = (1)^2;

//Fiscal VAR P 27.7
%var eps_taukhat = (0)^2;
%var eps_tauwhat = (0)^2;
%var eps_tauchat = (0)^2;
%var eps_tauyhat = (0)^2; 
%var eps_ghat    = (0)^2; 
%end; 

// *** Prior distribution: ***
estimated_params; 
//use [s,nu]=inverse_gamma_specification(0.002,inf,1) to verify that 
//stdev=inf  yields indeed 2 degrees of freedom
//MA: wrong prior for truncnormal and invgamma > 4df

%-------Calvo parameters block (nominal friction)--------------------------------------
%------probability that a firm/household is not allowed to reoptimise price/wage---
xiw,,,,        beta_pdf,0.675,0.05;  % Calvo wage
xid,,,,        beta_pdf,0.675,0.05;  % Calvo domestic price
%ximc,,,,       beta_pdf,0.675,0.05;  % Calvo import consumption price
%ximi,,,,       beta_pdf,0.675,0.05;  % Calvo import investment price
%xix,,,,        beta_pdf,0.675,0.05;  % Calvo export price
xie,,,,        beta_pdf,0.675,0.05;  % Calvo unemployment


%------------price and wage indexations (nominal friction)--------------- 
kappad,,,,       beta_pdf,0.5,0.15; % Indexation prices for domestic firm
kappaw,,,,       beta_pdf,0.5,0.15; % Indexation wages
%kappamc,,,,       beta_pdf,0.5,0.15; % Indexation prices for importing cons. firm
%kappami,,,,       beta_pdf,0.5,0.15; % Indexation prices for importing inves. firm
%kappax,,,,       beta_pdf,0.5,0.15; % Indexation prices for exporting firm 

%-------------------------------------------------------------------------

%------------Real frictions----------------------------------------------
 
SS,,,,         normal_pdf,7.694,1.5; % Investment adjustment cost
b,,,,          beta_pdf,0.65,0.2;    % Consumption habit formation
%-------------------------------------------------------------------------

%------------------3 Markups-----------------------------------------------

lambdaf,,,,        normal_pdf,1.2,0.05;      % Markup demestic
%lambdamc,,1.01,,   normal_pdf,1.2,0.05;      % Markup imported consumption
%lambdami,,1.01,,   normal_pdf,1.2,0.05;      % Markup imported invesment
%---------------------------------------------------------------------

%------------Substitution of elasticity------------------------------- 
etai,,,,       inv_gamma_pdf,1.5,inf;  % Subst. elasticity investment
etaf,,,,       inv_gamma_pdf,1.5,inf;  % Subst. elasticity foreign
%-------------------------------------------------------------------------

%muz,,,,        normal_pdf,1.0041,0.0005;   % Technolog growth is calibrated at the steady state output growth

phitilde,,,,   inv_gamma_pdf,0.01,inf;   % Risk premium
phitildes,,,,  beta_pdf,0.5,0.15;      % UIP modification

//------ 6 parameters in policy rule----------------- 
rhoR,,,,    beta_pdf,0.8,0.05;            % Interest Rate smoothing
rpie,,,,    normal_pdf,1.8,0.2;         % Inflation response
rdeltapi,,,, normal_pdf,0.3,0.05;       % Diff. Inflation response
% rx,,,, normal_pdf,0.01,0.05;             % 0.00 as prior mean, Real exchange rate response
ry,,,, normal_pdf,0.125,0.05;             %0.05;  Output response
rdeltay,,,, normal_pdf,0.0625,0.05;        % Diff. output response
%---------------------------------------------------------------------

%---------------------SHOCK PROCESS---------------------------

%---persistent paramters in AR process------------------------------------

rhomuz,,,,     beta_pdf,0.85,0.1;      % Unit root tech.shock
rhoeps,,,,     beta_pdf,0.85,0.1;      % Stationary tech. shock
rhoiota,,,,    beta_pdf,0.85,0.1;      % Unit root Investment specific technology shock
% rhophitilde,,,,beta_pdf,0.85,0.1;      % Unit root Risk premium shock
rhozetac,,,,   beta_pdf,0.85,0.1;      % Consumption preference
rhozetah,,,,   beta_pdf,0.85,0.1;      % Labor supply
rhozetatilde,,,,   beta_pdf,0.85,0.1;  % Unit root Asymmetric technology shock
%-------------------------------------------------------------------------



%stderr eps_muzhat,,,,   inv_gamma_pdf,0.2,inf;             % Non-stationary Technology shock

stderr eps_epshat,,,,   inv_gamma_pdf,0.7,inf;             % Stationary technology shock
%stderr eps_etamchat,,,,   inv_gamma_pdf,1,inf;             % Substitution elasticity imp cons goods shock
%stderr eps_etamihat,,,,   inv_gamma_pdf,1,inf;             % Substitution elasticity imp inv goods shock
stderr eps_lambdafhat,,,,   inv_gamma_pdf,1,inf;           % Domestic markup shock
stderr eps_upsilonhat,,,,   inv_gamma_pdf,0.2,inf;         % Investment specific technology shock
%stderr eps_phitildehat,,,,   inv_gamma_pdf,0.05,inf;       % Risk premium shock
stderr eps_zetachat,,,,   inv_gamma_pdf,0.2,inf;           % Consumption preference shock phuong modify
stderr eps_zetahhat,,,,   inv_gamma_pdf,1,inf;             % Labor supply shock, phuong modify stderr eps_zetahhat,,,,   inv_gamma_pdf,1.0*527.1575,inf
%stderr eps_zetatildehat,,,,   inv_gamma_pdf,0.4,inf;       % Asymmetric technology
%stderr eps_lambdaxhat,,,,   inv_gamma_pdf,1,inf;           % Markup export shock
stderr eps_epsRhat,,,,   inv_gamma_pdf,0.15,inf;           % Interest rate Shock
stderr eps_piThat,,,,   inv_gamma_pdf,0.05,inf;            % Inflation Target Shock

end;



//options_.aim_solver=1;
//identification(ar=1,useautocorr=0,prior_mc =50); // no idetification problem
//identification(ar=10); //P no idetification problem

estimation(
datafile=Trans_Aus_Dat_dynare,
plot_priors=0, % default =1
mode_compute=0,%4 (Chris Sim), 7 ( fminsearch Nelder-Mead 1965), 9 (Covariance Matrix Adaptation Evolution Strategy) algorithm of Hansen and Kern (2004))
%optim =('MaxIter',50000,'MaxFunEvals',50000),
mh_replic= 0,      % THE MOST IMPORTANCE. Number of draws for each Makov chain. Default: 20,000
mh_nblocks = 1,   % THE MOST IMPORTANCE. Number of parallel chains for Metropolis-Hasting Algorithm (Default=2, very low). it should be at least 5
mh_drop = 0.45,    % the number of burn-in. default =0.5
mh_jscale = 0.25,  % THE MOST IMPORTANCE. The scale for jumping distribution in the MH algorithm (default =0.2, rarely satisfactory)
                  % this scale must be tunned to make sure the acceptance rate ranging btw 0.2 and 0.4
                  % when Phuong set the jumping scale of 0.2 as a default number, then the acceptance ratio is
                  % over 0.4 (too high in comparison to literature only 0.2 and 0.4)
                  % that's why P increase the jump scale from default level of 0.2 to 0.3
                  % as a result, the acceptance ratio lies on the range btw 0.2 and 0.4
                  % the rule to adjust the jumping scale (c)
                  % if the acceptance ratio (R) is TOO LOW, then the jumping scale (c) should be REDUCED (WHY?)
                  % if the acceptance ratio (R) is TOO HIGH, then the jumping scale (c) should be INCREASED (WHY?)
%mh_init_scale=1 , % Like An & Schorfheide (2007)to generate a starting value for MH


//load_mh_file,  % VERY USEFUL TO SPEED UP.By loading the previuos MH simulation
//mode_file=ALEstim_pet_mode, % to use the previous likelihood result
mode_check_neighbourhood_size =1000,
//filtered_vars,
//filter_step_ahead=[1 2 1]
diffuse_filter % to stationanize data
//mode_check
//lik_init=1,      
//nograph=0
); 
xparam1= get_posterior_parameters('mean');
M_ = set_all_parameters(xparam1,estim_params_,M_);
stoch_simul(conditional_variance_decomposition = [1 4 8 12 20 40], irf=20) data_pid data_c data_i data_R data_y data_wp E_t  ;
 
/*
options_.trace_plot_ma=30000;
% MH Chain 1
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'xiw');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'xid');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'ximc');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'ximi');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'xix');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'xie');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'kappad');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'kappaw');

trace_plot(options_,M_,estim_params_,'DeepParameter',1,'kappamc');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'kappami');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'kappax'); 


trace_plot(options_,M_,estim_params_,'DeepParameter',1,'SS');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'b');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'lambdaf');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'lambdamc');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'lambdami');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'etai');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'etaf');

%trace_plot(options_,M_,estim_params_,'DeepParameter',1,'muz');

trace_plot(options_,M_,estim_params_,'DeepParameter',1,'phitilde');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'phitildes');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhoR');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rpie');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rdeltapi');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rx');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'ry');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rdeltay');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhomuz');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhoeps');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhoiota');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhophitilde');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhozetac');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhozetah');
trace_plot(options_,M_,estim_params_,'DeepParameter',1,'rhozetatilde');

%trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_muzhat');

trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_epshat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_etamchat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_etamihat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_lambdafhat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_upsilonhat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_phitildehat ');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_zetachat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_zetahhat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_zetatildehat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_lambdaxhat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_epsRhat');
trace_plot(options_,M_,estim_params_,'StructutalShock',1,'eps_piThat '); */

